Package: heritability
Type: Package
Title: Marker-Based Estimation of Heritability Using Individual Plant
        or Plot Data
Description: Implements marker-based estimation of heritability when observations on genetically identical replicates are available. These can be either observations on individual plants or plot-level data in a field trial. Heritability can then be estimated using a mixed model for the individual plant or plot data. For comparison, also mixed-model based estimation using genotypic means and estimation of repeatability with ANOVA are implemented. For illustration the package contains several datasets for the model species Arabidopsis thaliana.
Version: 1.5
Date: 2026-06-11
Authors@R: c(person(given = "Willem", 
                    family = "Kruijer",
                    role = "aut",
                    email = "wkruijer@protonmail.com"),
             person(given = "Ian",
                    family = "White",
                    role = "ctb",
                    comment = "the internal pin function"),
             person(given = "Padraic",
                    family = "Flood",
                    role = "dtc"),
             person(given = "Rik",
                    family = "Kooke",
                    role = "dtc"),
             person(given = "Bart-Jan", 
                    family = "van Rossum",
                    role = c("cre", "aut"),
                    email = "bart-jan.vanrossum@wur.nl")
             )
Depends: R (>= 4.0), MASS (>= 3.1.20)
Suggests: knitr, rmarkdown
License: GPL-3
NeedsCompilation: no
Packaged: 2026-06-11 12:03:10 UTC; rossu027
Author: Willem Kruijer [aut],
  Ian White [ctb] (the internal pin function),
  Padraic Flood [dtc],
  Rik Kooke [dtc],
  Bart-Jan van Rossum [cre, aut]
Maintainer: Bart-Jan van Rossum <bart-jan.vanrossum@wur.nl>
Repository: CRAN
Date/Publication: 2026-06-12 07:00:14 UTC
Built: R 4.5.2; ; 2026-06-12 10:40:01 UTC; unix

Package: heritability
Type: Package
Title: Marker-Based Estimation of Heritability Using Individual Plant
        or Plot Data
Description: Implements marker-based estimation of heritability when observations on genetically identical replicates are available. These can be either observations on individual plants or plot-level data in a field trial. Heritability can then be estimated using a mixed model for the individual plant or plot data. For comparison, also mixed-model based estimation using genotypic means and estimation of repeatability with ANOVA are implemented. For illustration the package contains several datasets for the model species Arabidopsis thaliana.
Version: 1.5
Date: 2026-06-11
Authors@R: c(person(given = "Willem", 
                    family = "Kruijer",
                    role = "aut",
                    email = "wkruijer@protonmail.com"),
             person(given = "Ian",
                    family = "White",
                    role = "ctb",
                    comment = "the internal pin function"),
             person(given = "Padraic",
                    family = "Flood",
                    role = "dtc"),
             person(given = "Rik",
                    family = "Kooke",
                    role = "dtc"),
             person(given = "Bart-Jan", 
                    family = "van Rossum",
                    role = c("cre", "aut"),
                    email = "bart-jan.vanrossum@wur.nl")
             )
Depends: R (>= 4.0), MASS (>= 3.1.20)
Suggests: knitr, rmarkdown
License: GPL-3
NeedsCompilation: no
Packaged: 2026-06-11 12:03:10 UTC; rossu027
Author: Willem Kruijer [aut],
  Ian White [ctb] (the internal pin function),
  Padraic Flood [dtc],
  Rik Kooke [dtc],
  Bart-Jan van Rossum [cre, aut]
Maintainer: Bart-Jan van Rossum <bart-jan.vanrossum@wur.nl>
Repository: CRAN
Date/Publication: 2026-06-12 07:00:14 UTC
Built: R 4.6.0; ; 2026-06-12 09:26:59 UTC; unix

#' @name GINV
#' @title Title.
#' @description Description.
#' @param M blabla
#' @return blabla
#' @author Willem Kruijer \email{wkruijer@@protonmail.com}
#' @details blabla.
#' @examples blabla.
#' @export
GINV    <- function(M) {
  svdM    <- svd(M)
  return(svdM$v %*%diag(1/svdM$d)%*% t(svdM$u))
}

#' @name narrow
#' @title Title.
#' @description Description.
#' @param data.vector :  vector of phenotypic values
#' @param geno.vector :  vector (character or factor) of genotypes
#' @param K           :  kinship matrix, of class matrix. Column-names should contain all occurring genotypes (?)
#' @param covariates  :  additional covariates (which should not include an intercept, which is included automatically)
#' @param average.number.of.replicates :
#' @param alpha : confidence level, for the (1-alpha) confidence intervals
#' @return blabla
#' @author Willem Kruijer \email{wkruijer@@protonmail.com}
#' @details blabla.
#' @examples blabla.
#' @export
#' 
#' 

marker_h2_means <- function(data.vector,geno.vector,K,Dm=NULL,alpha=0.05,
                           eps=1e-06,max.iter=100,fix.h2=FALSE,h2=0.5,grid.size=99){

# OUTPUT :
# heritability, genetic - and residual variance

    if (is.null(rownames(K)) | is.null(colnames(K))) {
      stop('K should have row- and column-names corresponding to the levels of geno.vector')
    }
  
  
    if (is.null(Dm)) {
      Dm <- diag(nrow(K))
      rownames(Dm) <- colnames(Dm) <- colnames(K)
      cat('Warning: it is assumed that each phenotypic values corresponds to an observation on a single individual.','\n')
      cat('If each phenotypic value is the mean of observations on r genetically identical individuals in a completely randomized design,','\n')
      cat('Dm should be diag(1/r,nrow=nrow(K)). More generally, in other designs, Dm should be the covariance matrix of the genotypic means. ','\n')
    } 
    
    if (is.null(rownames(Dm)) | is.null(colnames(Dm))) {
      stop('Dm should have row- and column-names corresponding to the levels of geno.vector')
    }
    
    her.frame            <- data.frame(dat=data.vector,genotype=geno.vector)
    her.frame$genotype   <- as.character(her.frame$genotype)

    her.frame     <- her.frame[!is.na(her.frame$dat),]

    # re-scale the kinship matrix, for those genotypes for which phenotypic data are available
    K <- K[unique(her.frame$genotype),unique(her.frame$genotype)]
    K <- K / KinshipTransform(K)

    #if (is.null(Dm)) {Dm <- K} else {
    Dm <- Dm[unique(her.frame$genotype),unique(her.frame$genotype)]

    VALUE <- as.data.frame(her.frame$dat)
    names(VALUE)[1] <- 'value'
    
    ######################
            
    reml.obj <- AI_algorithm_weights(Y=data.frame(genotype=her.frame$genotype,VALUE),K=K,Dm=Dm,eps=eps,max.iter=max.iter,fix.h2=fix.h2,h2=h2)

    if (reml.obj$converge == FALSE) {
      h2.grid     <- (1:grid.size)/(grid.size+1)
      Y <- rep(NA,grid.size)
      for (i in 1:grid.size) {
        Y[i]           <- AI_algorithm_weights(Y=data.frame(genotype=her.frame$genotype,VALUE),K=K,Dm=Dm,eps=eps,max.iter=max.iter,fix.h2=TRUE,h2=h2.grid[i])$loglik
      }
      reml.obj <- AI_algorithm_weights(Y=data.frame(genotype=her.frame$genotype,VALUE),K=K,Dm=Dm,eps=eps,max.iter=max.iter,fix.h2=TRUE,h2=min(h2.grid[which.max(Y)]))
    
    } else{
      Y <- numeric(0)    
    }

    reml.obj$gammas        <- c(reml.obj$varcomp[1],1,reml.obj$varcomp[2])    
    names(reml.obj$gammas) <- c("giv(genotype, var = TRUE).giv","R!variance","R!units.var")
    reml.obj$gammas.type   <- c(2,1,2)
    names(reml.obj$gammas.type) <- names(reml.obj$gammas)
    reml.obj$ai            <- reml.obj$inv.ai[lower.tri(reml.obj$inv.ai,diag=TRUE)] #reml.obj$inv.ai
    reml.obj$ai            <- c(reml.obj$ai[1],0,0,reml.obj$ai[2],0,reml.obj$ai[3])

    var.comp <- reml.obj$varcomp

    inv.ai <- reml.obj$inv.ai

    h2.estimate <- var.comp[1] / (var.comp[1] + var.comp[2])
    st.error1 <- as.numeric(pin(reml.obj,h2 ~ V1 / (V1 + V3))[2])
    conf.int1 <- c(h2.estimate - qnorm(1-alpha/2)*st.error1,h2.estimate + qnorm(1-alpha/2)*st.error1)

    st.error2 <- as.numeric(pin(reml.obj,h2 ~ log(V3 / V1))[2])
    conf.int2 <- c(1 / (1 + exp(log(var.comp[2] /var.comp[1]) + qnorm(1-alpha/2)*st.error2)),1 / (1 + exp(log(var.comp[2]/var.comp[1]) - qnorm(1-alpha/2)*st.error2)))

return(list(va=var.comp[1],ve=var.comp[2],h2=h2.estimate,conf.int1=conf.int1,conf.int2=conf.int2,
            inv.ai=reml.obj$inv.ai,loglik=reml.obj$loglik,loglik.vector=Y))

}

# inv.ai.varcomp=reml.obj$inv.ai.new

#' @name pin
#' @title Title.
#' @description Description.
#' @param object Output of either asreml or the function AI_algorithm
#' @param transform The transformation used in the delta-method
#' @return blabla
#' @author VSNI?
#' @details blabla.
#' @examples blabla.
#' @export
#' @references \\url{http://homepages.ed.ac.uk/imsw/asreml/useofpin.pdf}
#'             Most of it is borrowed from Venables and Ripley, S Programming, p170
#
pin <- function (object, transform) {
  pframe <- as.list(object$gammas)
  names(pframe) <- paste("V", seq(1, length(pframe)), sep = "")
  tvalue <- eval(deriv(transform[[length(transform)]], names(pframe)),pframe)
  X <- as.vector(attr(tvalue, "gradient"))
  X[object$gammas.type == 1] <- 0
  tname <- if (length(transform) == 3)
  transform[[2]]
  else ""
  n <- length(pframe)
  i <- rep(1:n, 1:n)
  j <- sequence(1:n)
  k <- 1 + (i > j)
  Vmat <- object$ai
  se <- sqrt(sum(Vmat * X[i] * X[j] * k))
  data.frame(row.names = tname, Estimate = tvalue, SE = se)
}

#' @name KinshipTransform
#' @title Title.
#' @description Description.
#' @param Matrix blabla
#' @return blabla
#' @author Willem Kruijer \email{wkruijer@@protonmail.com}
#' @details blabla.
#' @examples blabla.
#' @export
KinshipTransform <- function(Matrix) {
  nn <- ncol(Matrix)
  return((sum(diag(Matrix))-as.numeric(matrix(1,1,nn) %*% Matrix %*% matrix(1,nn,1))/nn)/(nn-1))
}

marker_h2 <-
function(data.vector,geno.vector,covariates=NULL,K,alpha=0.05,eps=1e-06,max.iter=100,fix.h2=FALSE,h2=0.5)   {

    her.frame            <- data.frame(dat=data.vector,genotype=geno.vector)
    her.frame$genotype   <- as.character(her.frame$genotype)

    if (!is.null(covariates)) {
      covariates            <- as.data.frame(covariates)
      n.cov                 <- ncol(covariates)
      names(covariates)     <- paste('c',1:n.cov,sep='')
      row.names(covariates) <- row.names(her.frame)
      her.frame             <- cbind(her.frame,covariates)
    }

    her.frame     <- her.frame[!is.na(her.frame$dat),]
    n.rep.vector  <- as.integer(table(her.frame$genotype))

    # re-scale the kinship matrix, for those genotypes for which phenotypic data are available
    K <- K[unique(her.frame$genotype),unique(her.frame$genotype)]
    K <- K / KinshipTransform(K)

    if (is.null(covariates)) {
      VALUE <- as.data.frame(her.frame$dat)
    } else {
      cov.part <- paste(paste('c',1:n.cov,sep=''),collapse='+')
      VALUE <- cbind(her.frame$dat,her.frame[,(ncol(her.frame)-n.cov+1):(ncol(her.frame))])
    }
    names(VALUE)[1] <- 'value'

    reml.obj <- AI_algorithm(Y=data.frame(genotype=her.frame$genotype,VALUE),K=K,eps=eps,max.iter=max.iter,fix.h2=fix.h2,h2=h2)

    reml.obj$gammas        <- c(reml.obj$varcomp[1],1,reml.obj$varcomp[2])

    names(reml.obj$gammas) <- c("giv(genotype, var = TRUE).giv","R!variance","R!units.var")
    reml.obj$gammas.type   <- c(2,1,2)
    names(reml.obj$gammas.type) <- names(reml.obj$gammas)
    reml.obj$ai            <- reml.obj$inv.ai[lower.tri(reml.obj$inv.ai,diag=TRUE)] #reml.obj$inv.ai


    reml.obj$ai            <- c(reml.obj$ai[1],0,0,reml.obj$ai[2],0,reml.obj$ai[3])
    var.comp <- reml.obj$varcomp

    inv.ai <- reml.obj$inv.ai.new


    h2.estimate <- var.comp[1] / (var.comp[1] + var.comp[2])

    st.error1 <- as.numeric(pin(reml.obj,h2 ~ V1 / (V1 + V3))[2])

    conf.int1 <- c(h2.estimate - qnorm(1-alpha/2)*st.error1,h2.estimate + qnorm(1-alpha/2)*st.error1)

    st.error2 <- as.numeric(pin(reml.obj,h2 ~ log(V3 / V1))[2])

    conf.int2 <- c(1 / (1 + exp(log(var.comp[2] /var.comp[1]) + qnorm(1-alpha/2)*st.error2)),1 / (1 + exp(log(var.comp[2]/var.comp[1]) - qnorm(1-alpha/2)*st.error2)))

return(list(va=var.comp[1],ve=var.comp[2],h2=h2.estimate,conf.int1=conf.int1,conf.int2=conf.int2,
            inv.ai=reml.obj$inv.ai,loglik=reml.obj$loglik))

}

#' @name AI_algorithm
#' @title Use the AI-algortihm (average ingormation; Gilmour et al 1995) to 
#'        obtain REML-estimates in a mixed model containing a random genetic effect and i.i.d. errors.   
#' @description This function is used for mixed-model based estimation of narrow-sense heritability using individual plant or plot data. 
#'              The input consists of a data.frame containing the individuals as rows, and with columns indicating their genotype, phenotype and possible covariates.   
#'              A kinship matrix is required, defining the genetic relatedness between the genotypes. 
#' @param Y  gsdfgsdfg
#' @param K  sdfgsdfgsdfgs
#' @param eps sdfgsdfgsg
#' @param max.iter sdfgsdfgsdfg  
#' @return a list with the following components:  a vector varcomp, containing respectively the estimated genetic- and residual variance; 
#'         a 2 x 2 matrix inv.ai, which is the inverse of the average information matrix; n.iter, the number of iterations until convergence; eps, the numerical precision
#'  
#' @author Willem Kruijer \email{wkruijer@@protonmail.com}
#' 
#' @details ...
#' @examples ...
#' @export              return(list(varcomp=varcomp,inv.ai=ginv(AI),inv.ai.new=ginv(AInew),n.iter=n.iter,eps=eps,loglik=loglik,converge=converge))
AI_algorithm <- function(Y,K,eps = 0.000000001,max.iter=25,escape=0.1,fix.h2=FALSE,h2=0.5) {   # X=matrix(rep(1,nrow(Y)))

  # Y=data.frame(genotype=her.frame$genotype,VALUE)
  #require(MASS)
  # eps : numerical error margin, used as convergence criterion
  # max.iter : maximal number of iterations

  # Y must be
  # - a vector (class numeric or integer), with

  #if (class(Y)=='integer') {class(Y)=='numeric'}

  #if (!(class(Y) %in% c('data.frame','numeric'))) {stop("Y should be of class data.frame, numeric or integer.")}

  #if (class(Y)=='numeric') {
  #  if (is.null(names(Y))) {stop("If Y is a vector of class numeric or integer, it should have names, i.e. the genotype names used in the kinship matrix.")}
  #  Y <- data.frame(genotype=names(Y),value=Y)
  #}

  #if (class(Y)=='data.frame') {
  #}

  #if (class(Y)=='matrix') {class(Y) <- 'data.frame'}
  #Y=data.frame(genotype=her.frame$genotype,value=her.frame$dat) ; eps = 0.000000001; max.iter=25

  # Y=data.frame(genotype=her.frame$genotype,VALUE) ; eps = 0.000000001 ; max.iter=25

  # escape : either zero, or 

  if (escape < 0 | escape >=0.5) {escape <- 0}

  if (!inherits(Y, 'data.frame')) {stop("Y should be of class data.frame")}
  if (!inherits(K, 'matrix') && !inherits(K, 'data.frame')) {stop("K should be of class matrix or data.frame")}
  if (inherits(K, 'data.frame')) {class(K) <- 'matrix'}
  if (is.null(colnames(K)) | is.null(rownames(K))) {stop("K should have column and row names")}

  #if (class(Y)!='data.frame') {stop("Y should be of class data.frame")}
  if (ncol(Y) < 2) {stop("Y should be a data.frame with at least two columns: \n The first column of Y should contain the genotype labels, and should be of class factor or character. \n The second column should contain the phenotypic values")}

  if (!inherits(Y[,1], 'factor') && !inherits(Y[, 1], 'character')) {stop("The first column of Y should contain the genotype labels, and should be of class factor or character.")}
  if (sum( unlist(lapply(Y,class)) %in% c('integer','numeric')) < (ncol(Y) - 1)) {stop("The first column of Y should contain the genotype labels; \n All other columns should be of type numeric or integer.")}

  # If there are no covariates, add an intercept
  if (ncol(Y)==2) {Y <- cbind(Y,rep(1,nrow(Y)))}

  var.cols <- apply(as.data.frame(Y[,-(1:2)]),2,var)

  # If there is no intercept (i.e. the original data-frame did have covariaates, but no intercept), 
  #   add an intercept to the data.frame
  if (sum(var.cols==0)==0) {Y <- cbind(Y,rep(1,nrow(Y)))}

  if (sum(var.cols==0)>1) {
    first.intercept <- which(var.cols==0)[1] + 2
    #Y <- Y[,-(first.intercept)]
    Y <- Y[,-((which(var.cols==0)[1] + 2)[-1])]
  }

  Y <- Y[!is.na(Y[,2]),]
  Y <- Y[!is.na(Y[,1]),]
  names(Y)[1:2] <- c('genotype','value')
  if (ncol(Y) > 2) {
    Y <- Y[apply(as.data.frame(Y[,-(1:2)]),1,function(x){sum(is.na(x))})==0,]
  }
  # other names ... ?

  if (!all(Y$genotype %in% colnames(K))) {
    no.kinship <- unique(Y$genotype[!(Y$genotype %in% colnames(K))])
    Y <- Y[Y$genotype %in% colnames(K),]
    if (nrow(Y)==0) {stop("Kinship information is not available for none of the individuals in Y")}
    warning(paste("K does not contain kinship information for genotypes",no.kinship,"; these genotypes are removed from Y."))
  }

  ########

  y <- as.matrix(Y[,2])
  X <- as.matrix(Y[,-(1:2)])

  K.original <- K
  K          <- K[as.character(Y$genotype),as.character(Y$genotype)]

  N   <- nrow(Y)
  
  n.iter <- 0
  
  converge <- TRUE
    
  ########
  

  if (!fix.h2) {
    
    # varcomp has two components: the genetic variance sigma_g^2 (varcomp[1]) and the residual variance sigma_e^2 (varcomp[2])
    varcomp.old <- c(0,0)
    # initialize
    varcomp <- rep(var(as.numeric(y)) / 2,2) # starting values genetic- and residual variance
      
    # Use the AI-alogortihm as described in Yang,  Hong Lee,Goddard and Visscher 2011 (GCTA paper)
  
    # initial step, following Yang et al (2011; GCTA paper) : update genetic variance following the EM-algorithm
    Vinv           <- ginv(varcomp[1] * K + varcomp[2] * diag(N))
    
    ginvXVX        <- ginv(t(X) %*% Vinv %*% X)
    
    VinvX          <- Vinv %*% X
    
    P              <- Vinv - (VinvX %*% (ginvXVX %*% t(VinvX)))
  
    varcomp.old[1] <- varcomp[1]
    
    Py             <- P %*% y
    
    varcomp[1]     <- (1/N) * ((varcomp[1])^2 * as.numeric(t(Py) %*% (K %*% Py) + sum(diag(varcomp[1] * diag(N) - (varcomp[1])^2 * P %*% K)) ))
    varcomp[2]     <- max(0,var(as.numeric(y)) - varcomp[1])

    # reset negative values
    if (sum(varcomp < 0) > 0) {
      guess <- runif(n=1)      
      varcomp <- c(guess * var(as.numeric(y)), (1-guess) * var(as.numeric(y)) ) 
    }

    #if (varcomp[1] < 0) {varcomp <- c(0.1 * var(as.numeric(y)), 0.9 * var(as.numeric(y)) ) }
    #if (varcomp[2] < 0) {varcomp <- c(0.9 * var(as.numeric(y)), 0.1 * var(as.numeric(y)) ) }  
      
    # continue with the AI-algorthm
    
    while (sum((varcomp.old - varcomp)^2) > eps & n.iter < max.iter) {
  
      Vinv           <- ginv(varcomp[1] * K + varcomp[2] * diag(N))
      
      ginvXVX        <- ginv(t(X) %*% Vinv %*% X)
      
      VinvX          <- Vinv %*% X
      
      P              <- Vinv - (VinvX %*% (ginvXVX %*% t(VinvX)))      

      Py             <- P %*% y
      
      KP             <- K %*% P
      PKP            <- P %*% KP
      KPK            <- KP %*% K
      
      #P              <- Vinv - (Vinv %*% X %*% ginv(t(X) %*% Vinv %*% X) %*% t(X) %*% Vinv)
      deltaL         <- - 0.5 * c(sum(apply(P * K, 1,sum)) - t(Py) %*% (K %*% Py), sum(diag(P)) -  sum(Py^2)) # t(y) %*% P %*% P %*% y
      
      
      AI     <- matrix(0,2,2)
      AI[1,2]<- AI[2,1] <- 0.5 * as.numeric(t(y) %*% (PKP %*% Py))
      AI[1,1]<- 0.5 * as.numeric(t(Py) %*% (KPK %*% Py))
      AI[2,2]<- 0.5 * as.numeric(t(Py) %*% (P %*% Py))
  
      varcomp.old <- varcomp
      varcomp     <- varcomp + as.numeric(ginv(AI) %*% deltaL)
  
      # reset negative values
      if (sum(varcomp < 0) ==2) {rep(var(as.numeric(y)) / 2,2)}
  
  
      if (escape > 0) { 
        guess <- runif(1,0,escape)
        if (varcomp[1] < 0) {varcomp <- c(guess * var(as.numeric(y)), (1-guess) * var(as.numeric(y)) ) }
        if (varcomp[2] < 0) {varcomp <- c((1-guess) * var(as.numeric(y)), guess * var(as.numeric(y)) ) }
      }
      if (escape==0) {
        if (varcomp[1] < 0) {varcomp <- c(0.001 * var(as.numeric(y)), 0.999 * var(as.numeric(y)) ) }
        if (varcomp[2] < 0) {varcomp <- c(0.999 * var(as.numeric(y)), 0.001 * var(as.numeric(y)) ) }
      }
      
      n.iter <- n.iter + 1
  
      cat('Iteration: ',n.iter,'\t',varcomp,'\n')
    }
    
    if (sum((varcomp.old - varcomp)^2) > eps & n.iter == max.iter) {
      warning('No convergence in AI-algorithm.')
      converge <- FALSE
    }

    # FINAL ESTIMATE AI-MATRIX
    Vinv           <- ginv(varcomp[1] * K + varcomp[2] * diag(N))
    P              <- Vinv - (Vinv %*% X %*% ginv(t(X) %*% Vinv %*% X) %*% t(X) %*% Vinv)    
    AI     <- matrix(0,2,2)
    AI[1,2]<- AI[2,1] <- 0.5 * as.numeric(t(y) %*% P %*% K %*% P %*% P %*% y)
    AI[1,1]<- 0.5 * as.numeric(t(y) %*% P %*% K %*% P %*% K %*% P %*% y)
    AI[2,2]<- 0.5 * as.numeric(t(y) %*% P %*% P %*% P %*% y)

  } else {            
    varcomp <- c(h2 * var(as.numeric(y)), (1-h2) * var(as.numeric(y)))
    
    Vinv   <- ginv(varcomp[1] * K + varcomp[2] * diag(N))
    P              <- Vinv - (Vinv %*% X %*% ginv(t(X) %*% Vinv %*% X) %*% t(X) %*% Vinv)
      
    deltaL <-  -0.5 * c(sum(diag(P %*% K)) - t(y) %*% P %*% K %*% P %*% y, sum(diag(P)) - t(y) %*% P %*% P %*% y )
      
    AI     <- matrix(0,2,2)
    AI[1,2]<- AI[2,1] <- 0.5 * as.numeric(t(y) %*% P %*% K %*% P %*% P %*% y)
    AI[1,1]<- 0.5 * as.numeric(t(y) %*% P %*% K %*% P %*% K %*% P %*% y)
    AI[2,2]<- 0.5 * as.numeric(t(y) %*% P %*% P %*% P %*% y)
    
  }

  ######################################
  
  # now redefine AI, to get the AI-matrix as defined by Gilmour et al 1995 (we denote their P with Pnew, to distinguish it from
  # the P used above, where we followed the notation of Yang,  Hong Lee,Goddard and Visscher 2011 (GCTA paper)

  Z <- matrix(0,nrow(y),ncol(K.original))
  for (i in 1:nrow(y)) {Z[i,which(rownames(K.original)==as.character(Y$genotype[i]))] <- 1}

  W  <- cbind(X,Z)
  tX_Z <- t(X) %*% Z 
  Cm <- rbind(cbind(t(X) %*% X,tX_Z),cbind(t(tX_Z),t(Z) %*% Z + (varcomp[2]/varcomp[1]) * GINV(K.original)))
  Pnew <- diag(N) - W %*% GINV(Cm) %*% t(W)

  AInew      <- AI
  AInew[1,2] <- AInew[2,1] <- 0.5 * as.numeric(t(y) %*% Pnew %*% K %*% Pnew %*% y) / (varcomp[2])^2
  AInew[1,1]<- 0.5 * as.numeric(t(y) %*% Pnew %*% K %*% Pnew %*% K %*% Pnew %*% y) / (varcomp[2])
  AInew[2,2]<- 0.5 * as.numeric(t(y) %*% Pnew %*% y) / (varcomp[2])^3

  ## 
  
  V <- varcomp[1] * K + varcomp[2] * diag(N)

  loglik <-  -0.5 * (2*sum(log(diag(chol(V))))  + log(det(t(X) %*% Vinv %*% X)) +  t(y) %*% P %*% y)   


  #return(list(varcomp=varcomp,inv.ai=ginv(AI),inv.ai.new=ginv(AInew),n.iter=n.iter,eps=eps,loglik=loglik,converge=converge))
# 17 sept. 2014: ginv ==> ginv
return(list(varcomp=varcomp,inv.ai=GINV(AI),inv.ai.new=GINV(AInew),n.iter=n.iter,eps=eps,loglik=loglik,converge=converge))
}

#' @name AI_algorithm
#' @title Use the AI-algortihm (average ingormation; Gilmour et al 1995) to obtain REML-estimates in a mixed model containing a random genetic effect and iid errors.   
#' @description This function is used for mixed-model based estimation of narrow-sense heritability. 
#'              The input consists of a data.frame containing the individuals as rows, and with columns indicating their genotype, phenotype and possible covariates.   
#'              The data-frame can contain replicates of the same genotype. In addition, a kinship matrix is required, defining the genetic relatedness between the genotypes. 
#'              The vector of genetic effects is multivariate normal with...
#' @param w weigts 1/r_i , i=1...n
#' @param Y  gsdfgsdfg
#' @param K  sdfgsdfgsdfgs
#' @param eps sdfgsdfgsg
#' @param max.iter sdfgsdfgsdfg  
#' @return a list with the following components:  a vector varcomp, containing respectively the estimated genetic- and residual variance; 
#'         a 2 x 2 matrix inv.ai, which is the inverse of the average information matrix; n.iter, the number of iterations until convergence; eps, the numerical precision
#'  
#' @author Willem Kruijer \email{wkruijer@@protonmail.com}
#' 
#' @details
#' @examples
#' @export
#
#
AI_algorithm_weights <- function(Y,K,Dm,eps = 0.000000001,max.iter=100,
                                 escape=0.3,fix.h2=FALSE,h2=0.5) {
#
# We use the AI-alogortihm as described in Yang,  Hong Lee,Goddard and Visscher 2011 (GCTA paper)
#
# Model: a vector y (the second column of Y) has a normal distribution with covariance \sigma_A^2 K + \sigma_E^2 Dm,
#        where K is the kinship matrix.   
#        We will refer to Dm as the weight matrix. In case of a single observation per genotype, it is the identity
#        In case of a balanced CRD with r replicates, it is the identity divided by r
#        In the more general case, it is the covariance matrix of the BLUEs of the genotypes, by divided sigma^2, the estimated residual variance
#        The preceding quantities are obtained from fitting a linear model without an intercept, a fixed factor genotype (number of levels equal to the number of genotypes)
#        and possibly extra (fixed) terms (i.e. the intercept is included in the factor genotype)

  if (escape < 0 | escape >=0.5) {escape <- 0}

  if (!inherits(K, 'matrix') && !inherits(K, 'data.frame')) {stop("K should be of class matrix or data.frame")}
  if (inherits(K, 'data.frame')) {class(K) <- 'matrix'}
  if (is.null(colnames(K)) | is.null(rownames(K))) {stop("K should have column and row names")}

  if (!inherits(Dm, 'matrix') && !inherits(Dm, 'data.frame')) {stop("Dm should be of class matrix or data.frame")}
  if (inherits(Dm, 'data.frame')) {class(Dm) <- 'matrix'}
  if (is.null(colnames(Dm)) | is.null(rownames(Dm))) {stop("Dm should have column and row names")}

  if (!inherits(Y , 'data.frame')) {stop("Y should be of class data.frame")}
  if (ncol(Y) < 1) {stop("Y should be a data.frame with at least two columns: \n The first column of Y should contain the genotype labels, and should be of class factor or character. \n The second column should contain the phenotypic values.")}

  if (!inherits(Y[,1], 'factor') && !inherits(Y[, 1], 'character')) {stop("The first column of Y should contain the genotype labels, and should be of class factor or character.")}
  if (sum( unlist(lapply(Y,class)) %in% c('integer','numeric')) < (ncol(Y) - 1)) {stop("The first column of Y should contain the genotype labels; \n All other columns should be of type numeric or integer.")}

  if (max(table(Y[,1])) > 1) {stop("The first column of Y should contain the genotype labels, and each genotype should occur at most once.")}

  # If there are no covariates, add an intercept
  if (ncol(Y)==2) {Y <- cbind(Y,rep(1,nrow(Y)))}

  var.cols <- apply(as.data.frame(Y[,-(1:2)]),2,var)

  # If there is no intercept (i.e. the original data-frame did have covariaates, but no intercept), 
  #   add an intercept to the data.frame
  if (sum(var.cols==0)==0) {Y <- cbind(Y,rep(1,nrow(Y)))}

  if (sum(var.cols==0)>1) {
    first.intercept <- which(var.cols==0)[1] + 2
    Y <- Y[,-((which(var.cols==0)[1] + 2)[-1])]
  }

  Y <- Y[!is.na(Y[,2]),]
  Y <- Y[!is.na(Y[,1]),]
  names(Y)[1:2] <- c('genotype','value')
  if (ncol(Y) > 2) {
    Y <- Y[apply(as.data.frame(Y[,-(1:2)]),1,function(x){sum(is.na(x))})==0,]
  }

  if (!all(Y$genotype %in% colnames(K))) {
    no.kinship <- unique(Y$genotype[!(Y$genotype %in% colnames(K))])
    Y <- Y[Y$genotype %in% colnames(K),]
    if (nrow(Y)==0) {stop("Kinship information is not available for any of the genotypes in Y")}
    warning(paste("K does not contain kinship information for genotypes",no.kinship,"; these genotypes are removed from Y."))
  }

  if (!all(Y$genotype %in% colnames(Dm))) {
    no.Dm <- unique(Y$genotype[!(Y$genotype %in% colnames(Dm))])
    Y <- Y[Y$genotype %in% colnames(Dm),]
    if (nrow(Y)==0) {stop("Weights are not available for any of the genotypes in Y")}
    warning(paste("The Dm (weight) matrix does not contain information for genotypes",no.Dm,"; these genotypes are removed from Y."))
  }

  ########

  y <- as.matrix(Y[,2])
  X <- as.matrix(Y[,-(1:2)])

  K          <-  K[as.character(Y$genotype),as.character(Y$genotype)]
  Dm         <- Dm[as.character(Y$genotype),as.character(Y$genotype)]

  Dm_inv     <- ginv(Dm)

  N          <- nrow(Y)

  n.iter     <- 0

  converge <- TRUE
      
  ########
  
  if (!fix.h2) {
    
    # varcomp has two components: the genetic variance sigma_g^2 (varcomp[1]) and the residual variance sigma_e^2 (varcomp[2])
    varcomp.old <- c(0,0)
    # initialize
    varcomp <- rep(var(as.numeric(y)) / 2,2) # starting values genetic- and residual variance

    # WE DON'T use a first EM-step as described in Yang,  Hong Lee,Goddard and Visscher 2011 (GCTA paper)
    # ... and directly start with the AI-algorthm

    while (sum((varcomp.old - varcomp)^2) > eps & n.iter < max.iter) {
  
      Vinv   <- ginv(varcomp[1] * K + varcomp[2] * Dm)
      P      <- Vinv - (Vinv %*% X %*% ginv(t(X) %*% Vinv %*% X) %*% t(X) %*% Vinv)
      
      deltaL <- -0.5 * c(sum(diag(P %*% K)) - t(y) %*% P %*% K %*% P %*% y,sum(diag(P %*% Dm)) - t(y) %*% P %*% Dm %*% P %*% y)
      
      AI     <- matrix(0,2,2)
      AI[1,2]<- AI[2,1] <- 0.5 * as.numeric(t(y) %*% P %*% K %*% P %*% Dm %*% P %*% y)
      AI[1,1]<- 0.5 * as.numeric(t(y) %*% P %*% K %*% P %*% K %*% P %*% y)
      AI[2,2]<- 0.5 * as.numeric(t(y) %*% P %*% Dm %*% P %*% Dm %*% P %*% y)
  
      varcomp.old <- varcomp
      varcomp     <- varcomp + as.numeric(ginv(AI) %*% deltaL)
  
      # reset negative values
      #if (sum(varcomp < 0) ==2) {rep(var(as.numeric(y)) / 2,2)}
      if (sum(varcomp < 0) ==2) {
        guess <- runif(n=1)      
        varcomp <- c(guess * var(as.numeric(y)), (1-guess) * var(as.numeric(y)) ) 
      }
  
      if (escape > 0) { 
        guess <- runif(1,0,escape)
        if (varcomp[1] < 0) {varcomp <- c(guess * var(as.numeric(y)), (1-guess) * var(as.numeric(y)) ) }
        if (varcomp[2] < 0) {varcomp <- c((1-guess) * var(as.numeric(y)), guess * var(as.numeric(y)) ) }
      }
      if (escape==0) {
        if (varcomp[1] < 0) {varcomp <- c(0.001 * var(as.numeric(y)), 0.999 * var(as.numeric(y)) ) }
        if (varcomp[2] < 0) {varcomp <- c(0.999 * var(as.numeric(y)), 0.001 * var(as.numeric(y)) ) }
      }
      
      n.iter <- n.iter + 1
  
      cat('Iteration: ',n.iter,'\t',varcomp,'\n')
    }

    if (sum((varcomp.old - varcomp)^2) > eps & n.iter == max.iter) {
      warning('No convergence in AI-algorithm.')
      converge <- FALSE
    }
    
    # FINAL ESTIMATE AI-MATRIX
    Vinv   <- ginv(varcomp[1] * K + varcomp[2] * Dm)
    P      <- Vinv - (Vinv %*% X %*% ginv(t(X) %*% Vinv %*% X) %*% t(X) %*% Vinv)    
    AI     <- matrix(0,2,2)
    AI[1,2]<- AI[2,1] <- 0.5 * as.numeric(t(y) %*% P %*% K %*% P %*% Dm %*% P %*% y)
    AI[1,1]<- 0.5 * as.numeric(t(y) %*% P %*% K %*% P %*% K %*% P %*% y)
    AI[2,2]<- 0.5 * as.numeric(t(y) %*% P %*% Dm %*% P %*% Dm %*% P %*% y)
    
  } else {

    # profile likelihood, see e.g. Crainiceanu Ruppert (2004), bottom of p.3  (applied here without the lambda parametrization)
    VunscaledInv <- ginv(h2 * K + (1-h2) * Dm)
    betaHat      <- ginv(t(X) %*% VunscaledInv %*% X) %*% t(X) %*% VunscaledInv %*% y
    sigma2       <- (1 / ncol(VunscaledInv)) * t(y - X %*% betaHat) %*% VunscaledInv %*% (y - X %*% betaHat)
    varcomp <- c(h2 * sigma2, (1-h2) * sigma2)

    Vinv   <- ginv(varcomp[1] * K + varcomp[2] * Dm)
    P      <- Vinv - (Vinv %*% X %*% ginv(t(X) %*% Vinv %*% X) %*% t(X) %*% Vinv)
      
    deltaL <- -0.5 * c(sum(diag(P %*% K)) - t(y) %*% P %*% K %*% P %*% y,sum(diag(P %*% Dm)) - t(y) %*% P %*% Dm %*% P %*% y)
      
    AI     <- matrix(0,2,2)
    AI[1,2]<- AI[2,1] <- 0.5 * as.numeric(t(y) %*% P %*% K %*% P %*% Dm %*% P %*% y)
    AI[1,1]<- 0.5 * as.numeric(t(y) %*% P %*% K %*% P %*% K %*% P %*% y)
    AI[2,2]<- 0.5 * as.numeric(t(y) %*% P %*% Dm %*% P %*% Dm %*% P %*% y)    

  }

  ######################################
  
  # now redefine AI, to get the AI-matrix as defined by Gilmour et al 1995 (we denote their P with Pnew, to distinguish it from
  # the P used above, where we followed the notation of Yang,  Hong Lee,Goddard and Visscher 2011 (GCTA paper)

  W  <- cbind(X,diag(N))

  tX_Z <- t(X) %*% Dm_inv #apply(Z,2,sum)

  Cm <- rbind(cbind(t(X) %*% Dm_inv %*% X,tX_Z),cbind(t(tX_Z),Dm_inv + (varcomp[2]/varcomp[1]) * ginv(K)))

  Pnew <- Dm_inv - Dm_inv %*% W %*% ginv(Cm) %*% t(W) %*% Dm_inv
  
  ###########
  
  AInew      <- AI
  AInew[1,2] <- AInew[2,1] <- 0.5 * as.numeric(t(y) %*% Pnew %*% K %*% Pnew %*% y) / (varcomp[2])^2
  AInew[1,1] <- 0.5 * as.numeric(t(y) %*% Pnew %*% K %*% Pnew %*% K %*% Pnew %*% y) / (varcomp[2])
  AInew[2,2] <- 0.5 * as.numeric(t(y) %*% Pnew %*% y) / (varcomp[2])^3

  ############

  V <- varcomp[1] * K + varcomp[2] * Dm

  # log(det(V)) ==> 2*sum(log(diag(chol(V))))

  loglik <-  -0.5 * (2*sum(log(diag(chol(V))))  + log(det(t(X) %*% Vinv %*% X)) +  t(y) %*% P %*% y)   

  return(list(varcomp=varcomp,inv.ai=ginv(AI),inv.ai.new=ginv(AInew),n.iter=n.iter,eps=eps,loglik=loglik,converge=converge))
}

repeatability <-
function (data.vector, geno.vector, line.repeatability = FALSE,
    covariates.frame = data.frame())
{

# data.vector=d$y; geno.vector=d$genotype; covariates.frame = data.frame(d$x); line.repeatability = FALSE

    stopifnot(length(geno.vector) == length(data.vector))
    her.frame <- data.frame(dat = data.vector, geno = geno.vector)
    her.frame <- her.frame[!is.na(her.frame$dat), ]
    number.of.covariates <- 0
    if (nrow(covariates.frame) > 0) {
        stopifnot(nrow(covariates.frame) == length(data.vector))
        cov.names <- names(covariates.frame)
        number.of.covariates <- length(cov.names)
        covariates.frame <- as.data.frame(covariates.frame[!is.na(data.vector),
            ])
        names(covariates.frame) <- cov.names
        her.frame <- cbind(her.frame, covariates.frame)
        her.frame <- her.frame[apply(covariates.frame, 1, function(x) {
            sum(is.na(x))
        }) == 0, ]
    }
    her.frame$geno <- factor(her.frame$geno)
    n.rep.vector <- as.integer(table(her.frame$geno))
    n.geno <- length(n.rep.vector)
    average.number.of.replicates <- (sum(n.rep.vector) - sum(n.rep.vector^2)/sum(n.rep.vector))/(length(n.rep.vector) -
        1)
    if (max(n.rep.vector) == 1) {
        return(list(repeatability = NA, gen.variance = NA, res.variance = NA))
    }
    else {
        if (nrow(covariates.frame) > 0) {
            av <- anova(lm(as.formula(paste("dat~", paste(cov.names,
                collapse = "+"), "+geno")), data = her.frame))
        }
        else {
            av <- anova(lm(dat ~ geno, data = her.frame))
        }
        gen.variance <- (av[[3]][1 + number.of.covariates] - av[[3]][2 + number.of.covariates])/average.number.of.replicates
        if (gen.variance < 0) {
            gen.variance <- 0
        }
        if (line.repeatability) {
            res.variance <- av[[3]][2 + number.of.covariates]/average.number.of.replicates
        }
        else {
            res.variance <- av[[3]][2 + number.of.covariates]
        }
        if (!line.repeatability) {
            F.ratio <- av[[3]][1 + number.of.covariates]/av[[3]][2 + number.of.covariates]
            df.1 <- n.geno - 1
            df.2 <- av[[1]][2 + number.of.covariates]
            F.L <- qf(0.025, df1 = df.1, df2 = df.2, lower.tail = TRUE)
            F.U <- qf(0.975, df1 = df.1, df2 = df.2, lower.tail = TRUE)
            conf.int.left <- (F.ratio/F.U - 1)/(F.ratio/F.U +
                average.number.of.replicates - 1)
            conf.int.right <- (F.ratio/F.L - 1)/(F.ratio/F.L +
                average.number.of.replicates - 1)
            if (conf.int.left < 0) {
                conf.int.left <- 0
            }
            if (conf.int.right > 1) {
                conf.int.right <- 1
            }
            if (conf.int.left > 1) {
                conf.int.left <- 1
            }
            if (conf.int.right < 0) {
                conf.int.right <- 0
            }
        }
        else {
            conf.int.left <- NA
            conf.int.right <- NA
        }
        return(list(repeatability = gen.variance/(gen.variance +
            res.variance), gen.variance = gen.variance, res.variance = res.variance,
            line.repeatability = line.repeatability, average.number.of.replicates = average.number.of.replicates,
            conf.int = c(conf.int.left, conf.int.right)))
    }
}

\name{R_matrix}
\alias{R_matrix}
\alias{R_matrix_LDV}
\alias{R_matrix_LD}
\docType{data}
\title{
Covariance matrix of the accession means for flowering time.%Marker-based kinship matrix based on the Atwell \emph{et al.} (2010) data.
}
\description{
Covariance matrices of the accession means for flowering time contained in \code{\link{means_LD}}
and \code{\link{means_LDV}}, derived from the Atwell \emph{et al.} (2010) data.
}
\usage{data(R_matrix_LDV);data(R_matrix_LD)}
\format{
Matrix whose row- and column names are the ecotype-IDs of the accessions contained in
\code{\link{LD}} and \code{\link{LDV}}.
}
\details{
The matrix was computed as in Kruijer \emph{et al.}, Appendix A.
}
%\source{
%Atwell \emph{et al.} (2010).
%}
\references{
\itemize{
\item Atwell, S., Y. S. Huang, B. J. Vilhjalmsson, G. Willems, M. Horton, \emph{et al.} (2010)
Genome-wide association study of 107 phenotypes in Arabidopsis thaliana inbred lines. Nature
465: 627-631.
\item Kruijer, W. \emph{et al.} (2015) Marker-based estimation of heritability in immortal
populations. \emph{Genetics}, Vol. 199(2), p. 1-20.
}
}
\seealso{
Together with the corresponding means contained in \code{\link{means_LD}} and \code{\link{means_LDV}},
these matrices can be used to estimate heritability, using the function \code{\link{marker_h2_means}}.
}
%For the corresponding accession means, see \code{\link{means_LD}} and \code{\link{means_LDV}}.
\examples{
data(R_matrix_LD); data(R_matrix_LDV)
}
\keyword{datasets}

\name{marker_h2}
\alias{marker_h2}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Compute a marker-based estimate of heritability, given phenotypic observations
at individual plant or plot level. % (Kruijer \emph{et al.})
}
\description{
Given a genetic relatedness matrix and phenotypic observations at individual
plant or plot level, this function computes REML-estimates of the genetic and
residual variance and their standard errors, using the AI-algorithm (Gilmour \emph{et al.} 1995).
Based on this, heritability estimates and confidence intervals are given
(the estimator \eqn{h_r^2} in Kruijer \emph{et al.}).
}
\usage{
marker_h2(data.vector, geno.vector, covariates = NULL, K, alpha = 0.05,
          eps = 1e-06, max.iter = 100, fix.h2 = FALSE, h2 = 0.5)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{data.vector}{
A vector of phenotypic observations. Needs to be of type numeric. May contain
missing values.
}
  \item{geno.vector}{
A vector of genotype labels, either a factor or character. This vector should
correspond to \code{data.vector}, and hence needs to be of the same length.
}
  \item{covariates}{
A data-frame or matrix with optional covariates, the rows corresponding to
the phenotypic observations in \code{data.vector} and \code{geno.vector}.
May contain missing values. Factors are not allowed, and need to be encoded by
columns of type numeric or integer. The data-frame or matrix should not contain an intercept,
which is included by default.
}
  \item{K}{
A genetic relatedness or kinship matrix, typically marker-based.
Must have row- and column-names corresponding to the levels of \code{geno.vector}
}
  \item{alpha}{
Confidence level, for the 1-alpha confidence intervals.
}
  \item{eps}{
Numerical precision, used as convergence criterion in the AI-algorithm.
}
  \item{max.iter}{
Maximal number of iterations in the AI-algorithm.
}
  \item{fix.h2}{
Compute the log-likelihood and inverse AI-matrix for a fixed heritability value. Default is \code{FALSE}.
}
  \item{h2}{
When \code{fix.h2} is \code{TRUE}, the value of the heritability. Must be of type numeric, between 0 and 1.
}
}
\details{
\itemize{
%
\item Given phenotypic observations \eqn{Y_{ij}} for genotypes \eqn{i=1,...,n} and replicates
\eqn{j = 1,...,n_i}, the mixed model
\eqn{Y_{ij} = \mu + G_i + E_{ij}}
is assumed. The vector of additive genetic effects \eqn{(G_1,...,G_n)'} follows a
multivariate normal distribution with mean zero and covariance \eqn{\sigma_A^2 K},
where \eqn{\sigma_A^2} is the additive genetic variance, and \eqn{K} is a genetic relatedness matrix derived from a dense set of markers.
The errors \eqn{E_{ij}} are independent and normally distributed with variance \eqn{\sigma_E^2}.
Under certain assumptions (see Speed \emph{et al.} 2012) the marker- or chip-heritability \eqn{h^2 = \sigma_A^2 / (\sigma_A^2 + \sigma_E^2)}
equals the narrow-sense heritability.
%
\item It is assumed that the genetic relatedness matrix \eqn{K} is scaled such that \eqn{trace(P K P) = n - 1}, where
\eqn{P} is the projection matrix \eqn{I_n - 1_n 1_n' / n}, for the identity matrix \eqn{I_n} and \eqn{1_n} being a column vector of ones.
If this is not the case, \eqn{K} is automatically scaled prior to fitting the mixed model.
%
\item The model can optionally include a term \eqn{X_{ij} \beta}, where \eqn{X_{ij}}
is the row vector with observations on \eqn{k} extra covariates and the vector \eqn{\beta} contains their effects.
In this case the argument \code{covariates} should be the (N x k) matrix or
data-frame with rows \eqn{X_{ij}} (N being the total number of observations).
Observations where either \eqn{Y_{ij}} or any of the covariates is missing are discarded.
%
\item Confidence intervals for heritability are constructed using the delta-method and the inverse AI-matrix.
The delta-method can be applied either directly to the
function \eqn{(\sigma_A^2,\sigma_E^2) -> \sigma_A^2 / (\sigma_A^2 + \sigma_E^2)} or to the function
\eqn{(\sigma_A^2,\sigma_E^2) -> log(\sigma_A^2 / \sigma_E^2)}. In the latter case,
a confidence interval for \eqn{log(\sigma_A^2 / \sigma_E^2)} is obtained, which is back-transformed to a confidence interval for heritability.
This approach (proposed in Kruijer \emph{et al.}) has the advantage that intervals are always contained in the unit interval.
%
\item The AI-algorithm is run for \code{max.iter} iterations. If by then there is no convergence a warning is printed and the current estimates are returned.
}
}
\value{
A list with the following components:
  \item{va}{:  REML-estimate of the (additive) genetic variance.}
  \item{ve}{:  REML-estimate of the residual variance.}
  \item{h2}{:  Plug-in estimate of heritability: \eqn{va / (va + ve)}.}
  \item{conf.int1}{:  1-alpha confidence interval for heritability.}
  \item{conf.int2}{:  1-alpha confidence interval for heritability, obtained by
  application of the delta method on a logarithmic scale.}
  \item{inv.ai}{:  The inverse of the average information (AI) matrix.}
  \item{loglik}{:  The log-likelihood.}
}
\references{
\itemize{
\item Gilmour \emph{et al.} Gilmour, A.R., R. Thompson and B.R. Cullis (1995) Average Information {REML}: An Efficient Algorithm for Variance Parameter
	Estimation in Linear Mixed Models. \emph{Biometrics}, volume 51, number 4, 1440-1450.
\item Kruijer, W. \emph{et al.} (2015) Marker-based estimation of heritability in immortal
populations. \emph{Genetics}, Vol. 199(2), p. 1-20.
\item Speed, D., G. Hemani, M. R. Johnson, and D.J. Balding (2012) Improved heritability
estimation from genome-wide snps. \emph{the American journal of human genetics} 91: 1011-1021.
}
}
\author{
Willem Kruijer.
}
%\note{
%Works well for small data-sets (i.e. at most 1000 observations).
%}
\seealso{
For marker-based estimation of heritability using genotypic means, see
\code{\link{marker_h2_means}}.
}
\examples{
data(LD)
data(K_atwell)
# Heritability estimation for all observations:
#out <- marker_h2(data.vector=LD$LD,geno.vector=LD$genotype,
#                 covariates=LD[,4:8],K=K_atwell)
# Heritability estimation for a randomly chosen subset of 20 accessions:
set.seed(123)
sub.set <- which(LD$genotype \%in\% sample(levels(LD$genotype),20))
out <- marker_h2(data.vector=LD$LD[sub.set],geno.vector=LD$genotype[sub.set],
                 covariates=LD[sub.set,4:8],K=K_atwell)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ heritability }
\keyword{ narrow-sense }
\keyword{ marker-based }

\name{means_floweringTime}
\alias{means_floweringTime}
\alias{means_LD}
\alias{means_LDV}
\docType{data}
\title{
Flowering time from Atwell \emph{et al.} (2010): accession means.
}
\description{
Accession means for the flowering time data contained in \code{\link{LD}} and \code{\link{LDV}}.
}
\usage{data(means_LD); data(means_LDV)}
\format{
  Data-frames with flowering time means:
  \describe{
    \item{\code{genotype}}{a factor, the levels being the accession or ecotype identifiers}
    \item{\code{LD}}{Flowering time under long days, in number of days}
    \item{\code{LDV}}{Flowering time under long days and vernalization, in number of days}
  }
}
\details{
Following Kruijer \emph{et al.} (appendix A)
these means were defined as the least-squares estimate for the factor accession, in a linear model
containing both accession and replicate effects.
Consequently there are differences compared to Atwell \emph{et al.} (2010), where just the
arithmetic averages are considered.
}
%\source{
%Atwell \emph{et al.} (2010).
%}
\references{
\itemize{
\item Atwell, S., Y. S. Huang, B. J. Vilhjalmsson, G. Willems, M. Horton, \emph{et al.} (2010)
Genome-wide association study of 107 phenotypes in Arabidopsis thaliana inbred lines. Nature
465: 627-631.
\item Kruijer, W. \emph{et al.} (2015) Marker-based estimation of heritability in immortal
populations. \emph{Genetics}, Vol. 199(2), p. 1-20.
}
}
\seealso{
Together with the covariance matrices contained in \code{\link{R_matrix_LD}} and
\code{\link{R_matrix_LDV}}, the means contained in \code{means_LD} and \code{means_LDV}
can be used to estimate heritability, using the function \code{\link{marker_h2_means}}.
For the corresponding genetic relatedness matrix, see \code{\link{K_atwell}}.
For the individual plant data, see \code{\link{floweringTime}}.
}
\examples{
data(means_LD)
data(means_LDV)
}
\keyword{datasets}

\name{heritability-package}
\alias{heritability-package}
\alias{heritability}
\docType{package}
\title{
Marker-Based Estimation of Heritability Using Individual Plant or Plot Data.
}
\description{
The package implements marker-based estimation
of heritability when observations on genetically identical replicates are available.
These can be either observations on individual plants (e.g. in a growth chamber) or plot-level data in a field trial.
The function \code{marker_h2} estimates heritability using a mixed model for the
individual plant or plot data, as proposed in Kruijer \emph{et al.}
For comparison, also mixed-model based estimation using genotypic means (\code{marker_h2_means})
and estimation of repeatability with ANOVA (\code{repeatability}) are implemented.
For illustration the package contains several datasets for the model species \emph{Arabidopsis thaliana}.
}
\author{
Willem Kruijer <wkruijer@protonmail.com>
Maintainer: Bart-Jan van Rossum <bart-jan.vanrossum@wur.nl>
}
\references{
Kruijer, W. \emph{et al.} (2015) Marker-based estimation of heritability in immortal
populations. \emph{Genetics}, Vol. 199(2), p. 1-20.
}
\keyword{ heritability }
\keyword{ mixed model }
\examples{
# A) marker-based estimation of heritability, given individual plant-data
# and a marker-based relatedness matrix:
data(LDV)
data(K_atwell)
# This may take up to 30 sec.
#out1 <- marker_h2(data.vector=LDV$LDV,geno.vector=LDV$genotype,
#                  covariates=LDV[,4:8],K=K_atwell)
#
# B) marker-based estimation of heritability, given genotypic means
# and a marker-based relatedness matrix:
data(means_LDV)
data(R_matrix_LDV)
data(K_atwell)
out2 <- marker_h2_means(data.vector=means_LDV$LDV,geno.vector=means_LDV$genotype,
                        K=K_atwell,Dm=R_matrix_LDV)
#
# C) estimation of repeatability using ANOVA:
data(LDV)
out3 <- repeatability(data.vector=LDV$LDV,geno.vector= LDV$genotype,
                      covariates.frame=as.data.frame(LDV[,3]))
}

\name{repeatability}
\alias{repeatability}
\title{ANOVA-based estimates of repeatability}
\description{
Given a population where each genotype is phenotyped for a number of genetically
identical replicates (either individual plants or plots in a field trial), the repeatability
or intra-class correlation can be estimated by
\eqn{V_g / (V_g + V_e)}, where \eqn{V_g = (MS(G) - MS(E)) / r} and \eqn{V_e = MS(E)}. In these expressions,
\eqn{r} is the number of replicates per genotype, and \eqn{MS(G)} and \eqn{MS(E)} are
the mean sums of squares for genotype and residual error obtained from analysis
of variance. In case \eqn{MS(G) < MS(E)}, \eqn{V_g} is set to zero.
See Singh \emph{et al.} (1993) or Lynch and Walsh (1998), p.563.
When the genotypes have differing numbers of replicates, \eqn{r} is replaced by
\eqn{\bar r = (n-1)^{-1} (R_1 - R_2 / R_1)}, where \eqn{R_1 = \sum r_i} and \eqn{R_2 = \sum r_i^2}.
Under the assumption that all differences between genotypes are genetic,
repeatability equals broad-sense heritability; otherwise it only provides an upper-bound for broad-sense heritability.
}
\usage{
repeatability(data.vector, geno.vector, line.repeatability = FALSE,
              covariates.frame = data.frame())
}
\arguments{
\item{data.vector}{A vector of phenotypic observations. Needs to be of type numeric. May contain
missing values.}
\item{geno.vector}{A vector of genotype labels, either a factor or character. This vector should
correspond to \code{data.vector}, and hence needs to be of the same length.}
\item{line.repeatability}{If \code{TRUE}, the line-repeatability or
line-heritability \eqn{\sigma_G^2 / (\sigma_G^2 + \sigma_E^2 / r)} is estimated,
otherwise (the default) the repeatability at plot- or plant level, which is \eqn{\sigma_G^2 / (\sigma_G^2 + \sigma_E^2)}.
}
\item{covariates.frame}{A data-frame with additional covariates, the rows corresponding to
\code{geno.vector} and the phenotypic observations in \code{data.vector}.
May contain missing values. Each column can be numeric or a factors.}
}
\value{
A list with the following components:
  \item{repeatability}{:  the estimated repeatability.}
  \item{gen.variance}{:  the estimated genetic variance.}
  \item{res.variance}{:  the estimated residual variance.}
  \item{line.repeatability}{:  whether repeatability was estimated at the
  individual plant or plot level (the default), or at the level of
  genotypic means (in the latter case, \code{line.repeatability=TRUE}) }
  \item{average.number.of.replicates}{:  The average number of replicates. See the description above.}
  \item{conf.int}{:  Confidence interval for repeatability. See Singh \emph{et al.} (1993) or Lynch and Walsh (1998)}
}
\references{
\itemize{
\item Kruijer, W. \emph{et al.} (2015) Marker-based estimation of heritability in immortal
populations. \emph{Genetics}, Vol. 199(2), p. 1-20.
\item Lynch, M., and B. Walsh (1998) Genetics and Analysis of Quantitative Traits. Sinauer As-
sociates, 1st edition.
\item Singh, M., S. Ceccarelli, and J. Hamblin (1993) Estimation of heritability from varietal
trials data. \emph{Theoretical and Applied Genetics} 86: 437-441.
}
}
\examples{
repeatability(data.vector=rep(rnorm(26),each=5) + rnorm(5*26),
              geno.vector=rep(letters,each=5))
}
\author{
Willem Kruijer
}

\name{BT_LW_H}
\alias{BT_LW_H}
\docType{data}
\title{
Bolting time and leaf width for the Arabidopsis hapmap population.
}
\description{
Bolting time and leaf width for the Arabidopsis hapmap population
}
\usage{data(BT_LW_H)}
\format{
  A data frame with phenotypic observations on bolting time and leaf width:
  \describe{
    \item{\code{genotype}}{a factor, the levels being the accession or ecotype identifiers}
    \item{\code{BT}}{Bolting time, in number of days}
    \item{\code{LW}}{Leaf width}
    \item{\code{replicate}}{The replicate (or block) each plant is contained in (factor with levels \code{1} to \code{3})}
    \item{\code{rep1}}{numeric encoding of the factor replicate: equals 1 if the plant is in replicate 1 and 0 otherwise}
\item{\code{rep2}}{numeric encoding of the factor replicate: equals 1 if the plant is in replicate 2 and 0 otherwise}
  }
}
%\details{
%Randomized complete block design. Missing values.
%}
%\source{
%Kruijer \emph{et al.} (2014).
%}
\author{
Willem Kruijer <wkruijer@protonmail.com>;
experiments conducted by Rik Kooke <rik.kooke@gmail.com>
}
\references{
\itemize{
\item Kruijer, W. \emph{et al.} (2015) Marker-based estimation of heritability in immortal
populations. \emph{Genetics}, Vol. 199(2), p. 1-20.
}
}
\seealso{
For the corresponding genetic relatedness matrix, see \code{\link{K_hapmap}}.
}
\examples{
data(BT_LW_H)
}
\keyword{datasets}

\name{floweringTime}
\alias{floweringTime}
\alias{LD}
\alias{LDV}
\docType{data}
\title{
Flowering time data taken from Atwell \emph{et al.} (2010).
}
\description{
Two data-frames containing individual plant data on flowering time under different conditions:
\code{LDV} (Flowering time under long days and vernalization) and \code{LD} (Flowering time under long days, without vernalization).
}
\usage{data(LD); data(LDV)}
\format{
  Data-frames with flowering time observations, genotype and design information:
  \describe{
    \item{\code{genotype}}{a factor, the levels being the accession or ecotype identifiers}
    \item{\code{LD}}{Flowering time under long days, in number of days}
    \item{\code{LDV}}{Flowering time under long days and vernalization, in number of days}
    \item{\code{replicate}}{The replicate (or block) each plant is contained in (factor with levels \code{1} to \code{6})}
    \item{\code{rep1}}{numeric encoding of the factor replicate: equals 1 if the plant is in replicate 1 and 0 otherwise}
\item{\code{rep2}}{numeric encoding of the factor replicate: equals 1 if the plant is in replicate 2 and 0 otherwise}
\item{\code{rep3}}{numeric encoding of the factor replicate: equals 1 if the plant is in replicate 3 and 0 otherwise}
\item{\code{rep4}}{numeric encoding of the factor replicate: equals 1 if the plant is in replicate 4 and 0 otherwise}
\item{\code{rep5}}{numeric encoding of the factor replicate: equals 1 if the plant is in replicate 5 and 0 otherwise}
  }
}
\details{
All plants that had not flowered by the end of the experiment were given a phenotypic value of 200.
Only accessions for which SNP-data are available are included here: 167 accessions in case of LD and 168 accessions in case of LDV.
}
%\source{
%Atwell \emph{et al.} (2010).
%}
\references{
\itemize{
\item Atwell, S., Y. S. Huang, B. J. Vilhjalmsson, G. Willems, M. Horton, \emph{et al.} (2010)
Genome-wide association study of 107 phenotypes in Arabidopsis thaliana inbred lines. Nature
465: 627-631.
\item Kruijer, W. \emph{et al.} (2015) Marker-based estimation of heritability in immortal
populations. \emph{Genetics}, Vol. 199(2), p. 1-20.
}
}
\seealso{
For the corresponding genetic relatedness matrix, see \code{\link{K_atwell}}.
}
\examples{
data(LD); data(LDV)
}
\keyword{datasets}

\name{leafArea}
\alias{leafArea}
\alias{LA_H}
\alias{LA_S}
\docType{data}
\title{
\emph{Arabidopsis} leaf area data for the hapmap and Swedish regmap population.
}
\description{
\emph{Arabidopsis} leaf area data for the hapmap and Swedish regmap population.
}
\usage{data(LA_H); data(LA_S)}

\format{
  Data frame with leaf area observations:
  \describe{
    \item{\code{genotype}}{a factor, the levels being the accession identifiers}
    \item{\code{LA13_H}}{Leaf area 13 days after sowing, in numbers of pixels (hapmap)}
    \item{\code{LA13_S}}{Leaf area 13 days after sowing, in numbers of pixels (Swedish regmap)}
    \item{\code{replicate}}{The replicate (or block) each plant is contained in (factor with levels \code{1} to \code{4})}
    \item{\code{rep1}}{numeric encoding of the factor replicate: equals 1 if the plant is in replicate 1 and 0 otherwise}
    \item{\code{rep2}}{numeric encoding of the factor replicate: equals 1 if the plant is in replicate 2 and 0 otherwise}
    \item{\code{rep3}}{numeric encoding of the factor replicate: equals 1 if the plant is in replicate 3 and 0 otherwise}
    \item{\code{x}}{The within image x-coordinate of the plant. A factor with levels \code{1} \code{2} \code{3}}
    \item{\code{y}}{The within image y-coordinate of the plant. A factor with levels \code{1} \code{2} \code{3} \code{4}}
    \item{\code{x1}}{numeric encoding of the factor \code{x}: equals 1 if the plant is in position 1 and 0 otherwise}
    \item{\code{x2}}{numeric encoding of the factor \code{x}: equals 1 if the plant is in position 2 and 0 otherwise}
    \item{\code{y1}}{numeric encoding of the factor \code{y}: equals 1 if the plant is in position 1 and 0 otherwise}
    \item{\code{y2}}{numeric encoding of the factor \code{y}: equals 1 if the plant is in position 2 and 0 otherwise}
    \item{\code{y3}}{numeric encoding of the factor \code{y}: equals 1 if the plant is in position 3 and 0 otherwise}
}
}
%\details{
%add.
%}
\author{
Willem Kruijer <wkruijer@protonmail.com>;
experiments conducted by Padraic Flood <flood@mpipz.mpg.de>
}
%\source{
%Kruijer, W. \emph{et al.}.
%}
\references{
\itemize{
\item Kruijer, W. \emph{et al.} (2015) Marker-based estimation of heritability in immortal
populations. \emph{Genetics}, Vol. 199(2), p. 1-20.
}
}
\seealso{
For the corresponding genetic relatedness matrices, see \code{\link{K_hapmap}} and \code{\link{K_swedish}}.
}
\examples{
data(LA_H); data(LA_S)
}
\keyword{datasets}

\name{K_arabidopsis}
\alias{K_atwell}
\alias{K_hapmap}
\alias{K_swedish}
\docType{data}
\title{
Marker-based relatedness matrices for 3 populations of Arabidopsis thaliana.
}
\description{
Marker-based relatedness matrices based on the SNP-data from Horton \emph{et al.} (2012).
Three matrices are provided:
(a) \code{K_atwell}, for the 199 accessions studied in Atwell \emph{et al.} (2010).
(b) \code{K_hapmap}, for a subset of 350 accessions taken from the Arabidopsis hapmap (Li \emph{et al.}, 2010).
(c) \code{K_swedish}, for 304 Swedish accessions.
All of these are part of the world-wide regmap of 1307 accessions, described in Horton \emph{et al.} (2012).
}
\usage{data(K_atwell); data(K_hapmap); data(K_swedish)}
\format{
Matrices whose row- and column names are the ecotype or seed-stock IDs of the accessions.
}
\details{
The matrices were computed using equation (2.2) in Astle and Balding (2009); see also
Goddard \emph{et al.} (2009). The \code{heritability}-package does not contain functions
to construct relatedness matrices from genotypic data, but such functions can be found in many other software packages.
For example, GCTA (Yang \emph{et al.}, 2011), LDAK (Speed \emph{et al.}, 2012), Fast-LMM (Lippert, 2011) and GEMMA (Zhou and Stephens, 2012).
}
\references{
\itemize{
\item W. Astle and D.J. Balding (2009) Population Structure and Cryptic Relatedness in Genetic Association Studies.
\emph{Statistical Science}, Vol. 24, No. 4, 451-471.
\item Atwell, S., Y. S. Huang, B. J. Vilhjalmsson, G. Willems, M. Horton, \emph{et al.} (2010)
Genome-wide association study of 107 phenotypes in Arabidopsis thaliana inbred lines. \emph{Nature}
465: 627-631.
\item Goddard, M.E., Naomi R. Wray, Klara Verbyla and Peter M. Visscher (2009) Estimating Effects and Making Predictions from Genome-Wide Marker Data.
\emph{Statistical Science}, Vol. 24, No. 4, 517-529.
\item Horton, M. W., A. M. Hancock, Y. S. Huang, C. Toomajian, S. Atwell, \emph{et al.}
(2012) Genome-wide patterns of genetic variation in worldwide Arabidopsis thaliana accessions
from the RegMap panel. \emph{Nature Genetics} 44: 212-216.
\item Li, Y., Y. Huang, J. Bergelson, M. Nordborg, and J. O. Borevitz (2010) Association
mapping of local climate-sensitive quantitative trait loci in arabidopsis thaliana. \emph{PNAS} vol. 107, number 49.
\item Lippert, C., J. Listgarten, Y. Liu, C.M. Kadie, R.I. Davidson, \emph{et al.} (2011) FaST
linear mixed models for genome-wide association studies. \emph{Naure methods} 8: 833-835.
\item Speed, D., G. Hemani, M. R. Johnson, and D.J. Balding (2012) Improved heritability
estimation from genome-wide snps. \emph{the American journal of human genetics} 91: 1011-1021.
\item Yang, J., S.H. Lee, M.E. Goddard, and P.M. Visscher (2011) GCTA: a tool for genomewide
complex trait analysis. \emph{the American journal of human genetics} 88: 76-82.
\item Zhou, X., and M. Stephens, (2012) Genome-wide efficient mixed-model analysis for association
studies. \emph{Nature genetics} 44: 821-824.
}
}
\seealso{
For phenotypic data for the population described in Atwell \emph{et al.} (2010), see \code{\link{LD}} and \code{\link{LDV}}.
For phenotypic data for the hapmap, see \code{\link{BT_LW_H}} and \code{\link{LA_H}}.
For phenotypic data for the Swedish regmap, see \code{\link{LA_S}}.
}
\examples{
data(K_atwell)
data(K_hapmap)
data(K_swedish)
}
\keyword{datasets}

\name{marker_h2_means}
\alias{marker_h2_means}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Compute a marker-based estimate of heritability, given genotypic means.% (Kruijer \emph{et al.})
}
\description{
Given a genetic relatedness matrix and genotypic means,
this function computes REML-estimates of the genetic and
residual variance and their standard errors, using the AI-algorithm (Gilmour \emph{et al.} 1995).
Based on this, heritability estimates and confidence intervals are given
(the estimator \eqn{h_m^2} in Kruijer \emph{et al.}).
}
\usage{
marker_h2_means(data.vector, geno.vector, K, Dm=NULL, alpha = 0.05, eps = 1e-06,
       max.iter = 100, fix.h2 = FALSE, h2 = 0.5, grid.size=99)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{data.vector}{
A vector of phenotypic observations, typically genotypic means. Needs to be of type numeric. May contain
missing values.
}
  \item{geno.vector}{
A vector of genotype labels, either a factor or character. This vector should
correspond to \code{data.vector}, and hence needs to be of the same length.
}
  \item{K}{
A genetic relatedness or kinship matrix, typically marker-based.
Must have row- and column-names corresponding to the levels of \code{geno.vector}
}
\item{Dm}{
Covariance of the genotypic means contained in data.vector; see details. Should be of class matrix, with row- and column-names corresponding to the levels of \code{geno.vector}
}
  \item{alpha}{
Confidence level, for the 1-alpha confidence intervals.
}
  \item{eps}{
Numerical precision, used as convergence criterion in the AI-algorithm.
}
  \item{max.iter}{
Maximal number of iterations in the AI-algorithm.
}
  \item{fix.h2}{
Compute the log-likelihood and inverse AI-matrix for a fixed heritability value. Default is \code{FALSE}.
}
  \item{h2}{
When \code{fix.h2} is \code{TRUE}, the value of the heritability. Must be of type numeric, between 0 and 1.
}
  \item{grid.size}{If the AI-algorithm has not converged after \code{max.iter} iterations,
the likelihood is computed on the grid of heritability values 1/(\code{grid.size}+1),...,\code{grid.size}/(\code{grid.size}+1); see details.
}
}
\details{
\itemize{
%
\item Given phenotypic observations \eqn{Y_{i}} for genotypes \eqn{i=1,...,n}, the mixed model
\eqn{Y_{i} = \mu + G_i + E_{i}}
is assumed. Typically, the \eqn{Y_{i}} are genotypic means or BLUEs obtained from fitting a linear (mixed) model to
the raw data, containing several plants or plots for each genotype.
The vector of additive genetic effects \eqn{(G_1,...,G_n)'} follows a
multivariate normal distribution with mean zero and covariance \eqn{\sigma_A^2 K},
where \eqn{\sigma_A^2} is the additive genetic variance, and \eqn{K} is a genetic relatedness matrix derived from a dense set of markers.
The vector of errors \eqn{(E_1,...,E_n)'} follows a
multivariate normal distribution with mean zero and covariance \eqn{\sigma_E^2 D_m},
where \eqn{D_m} is the covariance of the means obtained from the initial analysis.
In case of a completely randomized design with \eqn{r_i} replicates for genotypes
\eqn{i=1,...,n}, \eqn{D_m} is diagonal with elements \eqn{1 / r_i}.
Under certain assumptions (see Speed \emph{et al.} 2012) the marker- or chip-heritability \eqn{h^2 = \sigma_A^2 / (\sigma_A^2 + \sigma_E^2)}
equals the narrow-sense heritability.
%
\item As in the \code{\link{marker_h2}} function, it is assumed that the genetic relatedness matrix \eqn{K} is scaled such that \eqn{trace(P K P) = n - 1}, where
\eqn{P} is the projection matrix \eqn{I_n - 1_n 1_n' / n}, for the identity matrix \eqn{I_n} and \eqn{1_n} being a column vector of ones.
If this is not the case, \eqn{K} is automatically scaled prior to fitting the mixed model.
%
\item No covariates can be included, as it is assumed that these are available at plant- or plot level, and accounted for in the genotypic means.
%
\item The resulting heritability estatimes are less accurate than those obtained from individual plant or plot data, and the likelihood can be monotone
in \eqn{h^2 = \sigma_A^2 / (\sigma_A^2 + \sigma_E^2)}. If the AI-algorithm has not converged after \code{max.iter} iterations,
the likelihood is computed on the grid of heritability values 1/(\code{grid.size}+1),...,\code{grid.size}/(\code{grid.size}+1)
%
\item As in the \code{\link{marker_h2}} function, confidence intervals for heritability are constructed using the delta-method and the inverse AI-matrix.
The delta-method can be applied either directly to the
function \eqn{(\sigma_A^2,\sigma_E^2) -> \sigma_A^2 / (\sigma_A^2 + \sigma_E^2)} or to the function
\eqn{(\sigma_A^2,\sigma_E^2) -> log(\sigma_A^2 / \sigma_E^2)}. In the latter case,
a confidence interval for \eqn{log(\sigma_A^2 / \sigma_E^2)} is obtained, which is back-transformed to a confidence interval for heritability.
This approach (proposed in Kruijer \emph{et al.}) has the advantage that intervals are always contained in the unit interval.
%
}
}
\value{
A list with the following components:
  \item{va}{:  REML-estimate of the (additive) genetic variance.}
  \item{ve}{:  REML-estimate of the residual variance.}
  \item{h2}{:  Plug-in estimate of heritability: \eqn{va / (va + ve)}.}
  \item{conf.int1}{:  1-alpha confidence interval for heritability.}
  \item{conf.int2}{:  1-alpha confidence interval for heritability, obtained by
  application of the delta method on a logarithmic scale.}
  \item{inv.ai}{:  The inverse of the average information (AI) matrix.}
  \item{loglik}{:  The log-likelihood.}
  \item{loglik.vector}{:  Empty numeric vector if the AI-algorthm converged within \eqn{max.iter} iterations. Otherwise it contains the log-likelihood on a grid.}
}
%   \item{inv.ai.varcomp}{To do.}
\references{
\itemize{
\item Gilmour \emph{et al.} Gilmour, A.R., R. Thompson and B.R. Cullis (1995) Average Information {REML}: An Efficient Algorithm for Variance Parameter
	Estimation in Linear Mixed Models. \emph{Biometrics}, volume 51, number 4, 1440-1450.
\item Kruijer, W. \emph{et al.} (2015) Marker-based estimation of heritability in immortal
populations. \emph{Genetics}, Vol. 199(2), p. 1-20.
\item Speed, D., G. Hemani, M. R. Johnson, and D.J. Balding (2012) Improved heritability
estimation from genome-wide snps. \emph{the American journal of human genetics} 91: 1011-1021.
}
}
\author{
Willem Kruijer.
}
%\note{
%Works well for small data-sets (i.e. at most 1000 observations).
%}
\seealso{
For marker-based estimation of heritability using individual plant or plot data, see
\code{\link{marker_h2}}.
}
\examples{
data(means_LDV)
data(R_matrix_LDV)
data(K_atwell)
out <- marker_h2_means(data.vector=means_LDV$LDV,geno.vector=means_LDV$genotype,
                       K=K_atwell,Dm=R_matrix_LDV)
# Takes about a minute:
#data(means_LD)
#data(R_matrix_LD)
#out <- marker_h2_means(data.vector=means_LD$LD,geno.vector=means_LD$genotype,
#                       K=K_atwell,Dm=R_matrix_LD)
# The likelihood is monotone increasing:
#plot(x=(1:99)/100,y=out$loglik.vector,type="l",ylab="log-likelihood",lwd=2,
#     main='',xlab='h2',cex.lab=2,cex.axis=2.5)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ heritability }
\keyword{ narrow-sense }
\keyword{ marker-based }
